



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Pandas系列（七）-计算工具介绍</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Pandas系列（七）-计算工具介绍</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-27 19:59:22 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>内容目录</strong></p>
<ul><li>1. 统计函数</li>
<li>2. 窗口函数</li>
<li>3. 加深加强</li></ul>
<h4>　　数据准备</h4>
<div>
<pre class="prettyprint linenums"># 导入相关库<br />
import numpy as np<br />
import pandas as pd<br />
#Pandas 中包含了非常丰富的计算工具，如一些统计函数、窗口函数、聚合等计算工具。<br />
index = pd.Index(data=["Tom", "Bob", "Mary", "James", "Andy", "Alice"], name="name")<br />
data = {<br />
    "age": [18, 40, 28, 20, 30, 35],<br />
    "income": [1000, 4500 , 1800, 1800, 3000, np.nan],<br />
}<br />
df = pd.DataFrame(data=data, index=index)<br />
df<br />
Out[43]:<br />
       age  income<br />
name<br />
Tom     18  1000.0<br />
Bob     40  4500.0<br />
Mary    28  1800.0<br />
James   20  1800.0<br />
Andy    30  3000.0<br />
Alice   35     NaN</pre>
</div>
<h3>1.统计函数</h3>
<p>　　最常见的计算工具莫过于一些统计函数了。</p>
<p>　　这里我们首先构建一个包含了用户年龄与收入的 DataFrame。我们可以通过 cov 函数来求出年龄与收入之间的协方差，计算的时候会丢弃缺失值。除了协方差之外，我们还可以通过 corr 函数来计算下它们之间的相关性，计算的时候会丢弃缺失值。默认情况下 corr 计算相关性时用到的方法是 pearson，当然了你也可以指定 kendall 或 spearman。除了相关性的计算外，还可以通过 rank 函数求出数据的排名顺序。如果有相同的数，默认取其排名的平均值作为值。我们可以设置参数来得到不同的结果。可以设置的参数有：min、max、first、dense。</p>
<div>
<pre class="prettyprint linenums">#协方差<br />
df.age.cov(df.income)<br />
#相关系数<br />
df.age.corr(df.income)<br />
df.age.corr(df.income,method="kendall")<br />
df.age.corr(df.income,method="spearman")<br />
#排名<br />
df.income.rank()<br />
df.income.rank(method="first")　　</pre>
</div>
<h3>2.窗口函数</h3>
<p>　　有的时候，我们需要对不同窗口的中数据进行一个统计，常见的窗口类型为时间窗口。<br />　　例如，下面是某个餐厅 7 天的营业额，我们想要计算每两天的收入总额，如何计算呢?<br />通过 rolling 我们可以实现，设置 window=2 来保证窗口长度为 2，设置 on="date" 来保证根据日期这一列来滑动窗口（默认不设置，表示根据索引来欢动）</p>
<div>
<pre class="prettyprint linenums">data = {<br />
    "turnover": [12000, 18000, np.nan, 12000, 9000, 16000, 18000],<br />
    "date": pd.date_range("2018-07-01", periods=7)<br />
}<br />
df2 = pd.DataFrame(data=data)<br />
df2<br />
Out[44]:<br />
   turnover       date<br />
0   12000.0 2018-07-01<br />
1   18000.0 2018-07-02<br />
2       NaN 2018-07-03<br />
3   12000.0 2018-07-04<br />
4    9000.0 2018-07-05<br />
5   16000.0 2018-07-06<br />
6   18000.0 2018-07-07</pre>
</div>
<div>
<pre class="prettyprint linenums">df2.rolling(window=2, on="date").sum()<br />
Out[45]:<br />
   turnover       date<br />
0       NaN 2018-07-01<br />
1   30000.0 2018-07-02<br />
2       NaN 2018-07-03<br />
3       NaN 2018-07-04<br />
4   21000.0 2018-07-05<br />
5   25000.0 2018-07-06<br />
6   34000.0 2018-07-07<br />
#是不是发现，有很多结果是缺失值，导致这个结果的原因是因为在计算时，窗口中默认需要的最小数据个数与窗口长度一致，这里可以设置 min_periods=1 来修改下。<br />
df2.rolling(window=2, on="date", min_periods=1).sum()<br />
Out[46]:<br />
   turnover       date<br />
0   12000.0 2018-07-01<br />
1   30000.0 2018-07-02<br />
2   18000.0 2018-07-03<br />
3   12000.0 2018-07-04<br />
4   21000.0 2018-07-05<br />
5   25000.0 2018-07-06<br />
6   34000.0 2018-07-07<br />
#有时候，我想要计算每段时间的累加和，如何实现呢？先来看看第一种方式吧。<br />
df2.rolling(window=len(df2), on="date", min_periods=1).sum()<br />
Out[47]:<br />
   turnover       date<br />
0   12000.0 2018-07-01<br />
1   30000.0 2018-07-02<br />
2   30000.0 2018-07-03<br />
3   42000.0 2018-07-04<br />
4   51000.0 2018-07-05<br />
5   67000.0 2018-07-06<br />
6   85000.0 2018-07-07<br />
#还有另外一种方式，直接使用 expanding 来生成窗口。<br />
df2.expanding(min_periods=1)["turnover"].sum()<br />
Out[48]:<br />
0    12000.0<br />
1    30000.0<br />
2    30000.0<br />
3    42000.0<br />
4    51000.0<br />
5    67000.0<br />
6    85000.0<br />
Name: turnover, dtype: float64
</pre>
</div>
<h3>　3、加深加强</h3>
<pre class="prettyprint linenums">除了可以使用 sum 函数外，还有很多其他的函数可以使用，如：count、mean、median、min、max、std、var、quantile、apply、cov、corr等等。</pre>
<div>
<pre class="prettyprint linenums">方法	描述<br />
count()	非空观测值数量<br />
sum()	值的总和<br />
mean()	价值的平均值<br />
median()	值的算术中值<br />
min()	最小值<br />
max()	最大<br />
std()	贝塞尔修正样本标准差<br />
var()	无偏方差<br />
skew()	样品偏斜度（三阶矩）<br />
kurt()	样品峰度（四阶矩）<br />
quantile()	样本分位数（百分位上的值）<br />
apply()	通用适用<br />
cov()	无偏协方差（二元）<br />
corr()	相关（二进制）<br />
不过上面的方式只能生成一个结果，有时候想要同时求出多个结果（如求和和均值），如何实现呢？<br />
借助 agg 函数可以快速实现</pre>
</div>
<div>
<pre class="prettyprint linenums">df2.rolling(window=2, min_periods=1)["turnover"].agg([np.sum, np.mean])<br />
Out[52]:<br />
       sum     mean<br />
0  12000.0  12000.0<br />
1  30000.0  15000.0<br />
2  18000.0  18000.0<br />
3  12000.0  12000.0<br />
4  21000.0  10500.0<br />
5  25000.0  12500.0<br />
6  34000.0  17000.0<br />
#如果传入一个字典，可以为生成的统计结果重命名。<br />
df2.rolling(window=2, min_periods=1)["turnover"].agg({"tur_sum": np.sum, "tur_mean": np.mean})<br />
Out[53]:<br />
   tur_sum  tur_mean<br />
0  12000.0   12000.0<br />
1  30000.0   15000.0<br />
2  18000.0   18000.0<br />
3  12000.0   12000.0<br />
4  21000.0   10500.0<br />
5  25000.0   12500.0<br />
6  34000.0   17000.0
</pre>
</div>
<p>　　</p>
<p>　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1zrv69.html">javaScript对象－基本包装类型的详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93wk5zq.html">iOS开发之窥探UICollectionViewController&lpar;五&rpar; --一款炫酷的图片浏览组件</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8elgokq.html">SpringMVC&mdash;&mdash;form标签的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2pkl38.html">用C&num;开发的双色球走势图&lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjmemy9.html">Struts2笔记&mdash;&mdash;自定义拦截器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd45jjq.html">认识Agile，Scrum和DevOps</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k16mj69.html">asp&period;net中利用session对象传递、共享数据&lbrack;session用法&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z176m39.html">往另外1个ListView中添加当前选中的项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jw55o8.html">twemproxy 简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/95034j08.html">oracle常用的数据字典</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z74559.html">mysql数据库基本操作以及获取数据库强大帮助文档</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yg16g8.html">bzoj1003</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ylkkz8.html">ORA-00936&colon; missing expression</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj3jrk8.html">MySQL2&period;字符集乱码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllmzwkq.html">极速认识RSS！</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2w6y0q.html">RGBA alpha 透明度混合算法实现和测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2km0x9.html">Python数据分析Numpy库方法简介&lpar;三&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j5mv0q.html">pojA Star not a Tree&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1er5pq.html">javaweb防止表单重复提交</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7eom019.html">tcp线程聊天</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8eyng2e9.html">C&num;微信支付对接</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1k07n59.html">AngularJS学习之旅&mdash;AngularJS 服务&lpar;八&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgexnr8.html">js 学习之路7：switch&sol;case语句的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pd0rmz9.html">Linux 通过编译安装apache服务以及配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgexx48.html">Github如何提交修改的代码以及更新到最新版本</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1mkpdq.html">【PAT】B1014 福尔摩斯的约会</a>
			</li>
						<li><a href="https://www.batexi.com/a/9504o5z8.html">Windows的GDI映射方式，逻辑坐标，设备坐标的理解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkp7kj8.html">django 创建admin用户名跟密码</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojzzk5q.html">Java多线程与并发相关问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwj11wr8.html">centos7下 svn的配置</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
